from scapy.all import *

def process_http_get(payload, src_ip, dst_ip):
    # This function processes HTTP GET requests
    print(f"HTTP GET request from {src_ip} to {dst_ip}: {payload}")
    with open("http_logs.txt", "a") as log:
        log.write(f"HTTP GET from {src_ip} to {dst_ip}: {payload}\n")

def packet_callback(packet):
    # Check if the packet has an IP layer before proceeding
    if packet.haslayer(IP) and packet.haslayer(TCP):
        # Now it's safe to access the IP and TCP layers
        src_ip = packet[IP].src
        dst_ip = packet[IP].dst
        if packet[TCP].payload:  # Check if there's payload in TCP layer
            payload = packet[TCP].payload.load.decode('utf-8', errors='ignore')
            if packet[TCP].dport == 80 or packet[TCP].dport == 443:
                if "GET" in payload and "HTTP" in payload:
                    process_http_get(payload, src_ip, dst_ip)
            else:
                print(f"TCP packet from {src_ip} to {dst_ip} on port {packet[TCP].dport}")
    else:
        print("Non-IP/TCP packet captured")

def main():
    print("Starting enhanced packet sniffing...")
    sniff(iface='wlan0', filter="tcp", prn=packet_callback, store=0)

if __name__ == "__main__":
    main()
